﻿namespace Benday.JsonConverterSample
{
    public static class ExtensionMethods
    {
        public static string SafeToString(this string value, string defaultValue = "")
        {
            if (value == null)
            {
                return defaultValue;
            }
            else
            {
                return value;
            }
        }

        public static DateTime SafeToDateTime(this string value,
            DateTime defaultValue = default)
        {
            if (value == null)
            {
                return defaultValue;
            }
            else
            {
                if (DateTime.TryParse(value, out var returnValue) == true)
                {
                    return returnValue;
                }
                else
                {
                    return defaultValue;
                }
            }
        }
    }
}

