﻿// See https://aka.ms/new-console-template for more information
using System.Text.Json;
using Benday.JsonConverterSample;

var json = File.ReadAllText("sample.json");

// ParseUsingObjectValues(json);
ParseUsingTypedValues(json);

static void ParseUsingTypedValues(string json)
{
    var jsonAsTypes =
        JsonSerializer.Deserialize<WorkItemRevisionsResponseWithFieldsAsTypedValues>(json) ??
        throw new InvalidOperationException($"Nope. Something was wrong. Null value.");

    Console.WriteLine($"Item count: {jsonAsTypes.Value.Length}");

    foreach (var item in jsonAsTypes.Value)
    {
        Console.WriteLine($"Revision id '{item.Id}' as '{item.Fields.Count}' field(s)");

        foreach (var refname in item.Fields.Keys)
        {
            Console.WriteLine($"\t'{refname}'\tOld value: {item.Fields[refname].OldValue} --> {item.Fields[refname].NewValue}");
        }
    }
}

static void ParseUsingObjectValues(string json)
{
    var jsonAsTypes =
        JsonSerializer.Deserialize<WorkItemRevisionsResponseWithFieldsAsObjects>(json) ??
        throw new InvalidOperationException($"Nope. Something was wrong. Null value.");

    Console.WriteLine($"Item count: {jsonAsTypes.Value.Length}");

    foreach (var item in jsonAsTypes.Value)
    {
        Console.WriteLine($"Revision id '{item.Id}' as '{item.Fields.Count }' field(s)");
    }
}